diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index badffbf21..ab9f2d21a 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -11,142 +11,142 @@ public abstract class Achievements
 {
     public static List<Achievement> achievementList = new ArrayList<>();
     public static Achievement OPEN_INVENTORY =
-        new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", Items.BOOK, null)
+        new Achievement(NamespaceID.getPermanent("minecraft", "open_inventory"), "openInventory", Items.BOOK, null)
         .setClientsideAchievement().registerAchievement();
     public static Achievement MINE_WOOD =
-        new Achievement(new NamespaceID("minecraft", "mine_wood"), "mineWood", Blocks.LOG_OAK, OPEN_INVENTORY)
+        new Achievement(NamespaceID.getPermanent("minecraft", "mine_wood"), "mineWood", Blocks.LOG_OAK, OPEN_INVENTORY)
             .registerAchievement();
     public static Achievement BUILD_WORKBENCH =
-        new Achievement(new NamespaceID("minecraft", "build_workbench"), "buildWorkBench", Blocks.WORKBENCH, MINE_WOOD)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_workbench"), "buildWorkBench", Blocks.WORKBENCH, MINE_WOOD)
             .registerAchievement();
     public static Achievement BUILD_PICKAXE =
-        new Achievement(new NamespaceID("minecraft", "build_pickaxe"), "buildPickaxe", Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_pickaxe"), "buildPickaxe", Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement BUILD_FURNACE =
-        new Achievement(new NamespaceID("minecraft", "build_furnace"), "buildFurnace", Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_furnace"), "buildFurnace", Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
             .registerAchievement();
     public static Achievement ACQUIRE_IRON =
-        new Achievement(new NamespaceID("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
             .registerAchievement();
     public static Achievement GET_DIAMONDS =
-        new Achievement(new NamespaceID("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
+        new Achievement(NamespaceID.getPermanent("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement BUILD_HOE =
-        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_hoe"), "buildHoe", Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement MAKE_BREAD =
-        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", Items.FOOD_BREAD, BUILD_HOE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "make_bread"), "makeBread", Items.FOOD_BREAD, BUILD_HOE)
             .registerAchievement();
     public static Achievement BAKE_CAKE =
-        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_ICECREAM =
-        new Achievement(new NamespaceID("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_PUMPKIN_PIE =
-        new Achievement(new NamespaceID("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
             .registerAchievement();
     public static Achievement BUILD_BETTER_PICKAXE =
-        new Achievement(new NamespaceID("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
             .registerAchievement();
     public static Achievement COOK_FISH =
-        new Achievement(new NamespaceID("minecraft", "cook_fish"), "cookFish", Items.FOOD_FISH_COOKED, BUILD_FURNACE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "cook_fish"), "cookFish", Items.FOOD_FISH_COOKED, BUILD_FURNACE)
             .registerAchievement();
     public static Achievement ON_A_RAIL =
-        new Achievement(new NamespaceID("minecraft", "on_a_rail"), "onARail", Blocks.RAIL, ACQUIRE_IRON)
+        new Achievement(NamespaceID.getPermanent("minecraft", "on_a_rail"), "onARail", Blocks.RAIL, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement BUILD_SWORD =
-        new Achievement(new NamespaceID("minecraft", "build_sword"), "buildSword", Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.getPermanent("minecraft", "build_sword"), "buildSword", Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement ALL_ARMOR_TYPES =
-        new Achievement(new NamespaceID("minecraft", "all_armor_types"), "allArmorTypes", Items.ARMOR_CHESTPLATE_STEEL, null)
+        new Achievement(NamespaceID.getPermanent("minecraft", "all_armor_types"), "allArmorTypes", Items.ARMOR_CHESTPLATE_STEEL, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement KILL_ENEMY =
-        new Achievement(new NamespaceID("minecraft", "kill_enemy"), "killEnemy", Items.BONE, BUILD_SWORD)
+        new Achievement(NamespaceID.getPermanent("minecraft", "kill_enemy"), "killEnemy", Items.BONE, BUILD_SWORD)
             .registerAchievement();
     public static Achievement KILL_COW =
-        new Achievement(new NamespaceID("minecraft", "kill_cow"), "killCow", Items.LEATHER, BUILD_SWORD)
+        new Achievement(NamespaceID.getPermanent("minecraft", "kill_cow"), "killCow", Items.LEATHER, BUILD_SWORD)
             .registerAchievement();
     public static Achievement FLY_PIG =
-        new Achievement(new NamespaceID("minecraft", "fly_pig"), "flyPig", Items.SADDLE, KILL_COW)
+        new Achievement(NamespaceID.getPermanent("minecraft", "fly_pig"), "flyPig", Items.SADDLE, KILL_COW)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement GET_SENSED =
-        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
+        new Achievement(NamespaceID.getPermanent("minecraft", "get_sensed"), "getSensed", Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
             .registerAchievement();
     public static Achievement CRAFT_HANDCANNON =
-        new Achievement(new NamespaceID("minecraft", "craft_hand_cannon"), "craftHandCannon", Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "craft_hand_cannon"), "craftHandCannon", Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
             .registerAchievement();
     public static Achievement COLLECT_STONE =
-        new Achievement(new NamespaceID("minecraft", "collect_stone"), "collectStone", Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "collect_stone"), "collectStone", Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement CRUSH_BLOCKS =
-        new Achievement(new NamespaceID("minecraft", "crush_blocks"), "crushBlocks", Blocks.ICE, BUILD_BETTER_PICKAXE)
+        new Achievement(NamespaceID.getPermanent("minecraft", "crush_blocks"), "crushBlocks", Blocks.ICE, BUILD_BETTER_PICKAXE)
             .registerAchievement();
     public static Achievement REPAIR_ARMOR =
-        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", Items.CHAINLINK, KILL_ENEMY)
+        new Achievement(NamespaceID.getPermanent("minecraft", "repair_armor"), "repairArmor", Items.CHAINLINK, KILL_ENEMY)
             .registerAchievement();
     public static Achievement GET_CHAINMAIL =
-        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
+        new Achievement(NamespaceID.getPermanent("minecraft", "get_chainmail"), "getChainmail", Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement OPEN_GUIDEBOOK =
-        new Achievement(new NamespaceID("minecraft", "open_guidebook"), "openGuidebook", Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
+        new Achievement(NamespaceID.getPermanent("minecraft", "open_guidebook"), "openGuidebook", Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
             .setClientsideAchievement()
             .registerAchievement();
     public static Achievement CAUGHT_EM_ALL =
-        new Achievement(new NamespaceID("minecraft", "caught_em_all"), "caughtEmAll", Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.getPermanent("minecraft", "caught_em_all"), "caughtEmAll", Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement ALL_MUSIC_DISCS =
-        new Achievement(new NamespaceID("minecraft", "all_music_discs"), "allMusicDiscs", Items.RECORD_STAL, null)
+        new Achievement(NamespaceID.getPermanent("minecraft", "all_music_discs"), "allMusicDiscs", Items.RECORD_STAL, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement TRIPLE_HIT =
-        new Achievement(new NamespaceID("minecraft", "triple_hit"), "tripleHit", Items.AMMO_ARROW_GOLD, KILL_ENEMY)
+        new Achievement(NamespaceID.getPermanent("minecraft", "triple_hit"), "tripleHit", Items.AMMO_ARROW_GOLD, KILL_ENEMY)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
 
 
     // Nether achievements
     public static Achievement ENTER_NETHER =
-        new Achievement(new NamespaceID("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
+        new Achievement(NamespaceID.getPermanent("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement GET_NETHERCOAL =
-        new Achievement(new NamespaceID("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement LIGHT_SIGN =
-        new Achievement(new NamespaceID("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement SWIM_NETHER =
-        new Achievement(new NamespaceID("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement HIT_FIREBALL =
-        new Achievement(new NamespaceID("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement SLEEP_NETHER =
-        new Achievement(new NamespaceID("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
 //    public static Achievement ENTER_WARRENS =
-//        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
+//        new Achievement(NamespaceID.getPermanentNamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
 //            .setType(Achievement.TYPE_NORMAL)
 //            .registerAchievement();
     public static Achievement MOST_WANTED =
-        new Achievement(new NamespaceID("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement FAST_TRAVEL = // TODO
-        new Achievement(new NamespaceID("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
+        new Achievement(NamespaceID.getPermanent("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
 
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
index 54c25704e..a7d3f0f31 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
@@ -25,7 +25,7 @@ public class Stat
     public Stat(NamespaceID id, String key, StatValueFormatter statType)
     {
         clientside = false;
-        statId = id;
+        statId = id.makePermanent();
         statKey = key;
         this.statType = statType;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index b64152d60..ef3e4c5c3 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -34,51 +34,51 @@ public abstract class StatList
     public static final String STAT_MINED = "stat_mined";
 
     public static Stat startGameStat =
-        new StatBasic(new NamespaceID("minecraft", "start_game"), "stat.startGame").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "start_game"), "stat.startGame").setClientside().registerStat();
     public static Stat createWorldStat =
-        new StatBasic(new NamespaceID("minecraft", "create_world"), "stat.createWorld").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "create_world"), "stat.createWorld").setClientside().registerStat();
     public static Stat loadWorldStat =
-        new StatBasic(new NamespaceID("minecraft", "load_world"), "stat.loadWorld").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "load_world"), "stat.loadWorld").setClientside().registerStat();
     public static Stat joinMultiplayerStat =
-        new StatBasic(new NamespaceID("minecraft", "join_multiplayer"), "stat.joinMultiplayer").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "join_multiplayer"), "stat.joinMultiplayer").setClientside().registerStat();
     public static Stat leaveGameStat =
-        new StatBasic(new NamespaceID("minecraft", "leave_game"), "stat.leaveGame").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "leave_game"), "stat.leaveGame").setClientside().registerStat();
     public static Stat minutesPlayedStat =
-        new StatBasic(new NamespaceID("minecraft", "playtime"), "stat.playOneMinute", Stat.statTypeTime).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "playtime"), "stat.playOneMinute", Stat.statTypeTime).setClientside().registerStat();
     public static Stat distanceWalkedStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_walk"), "stat.walkOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_walk"), "stat.walkOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceSwumStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_swim"), "stat.swimOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_swim"), "stat.swimOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceFallenStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_fall"), "stat.fallOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_fall"), "stat.fallOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceClimbedStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_climb"), "stat.climbOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_climb"), "stat.climbOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceFlownStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_fly"), "stat.flyOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_fly"), "stat.flyOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceDoveStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_dive"), "stat.diveOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_dive"), "stat.diveOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByMinecartStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_minecart"), "stat.minecartOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_minecart"), "stat.minecartOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByBoatStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_boat"), "stat.boatOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_boat"), "stat.boatOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByPigStat =
-        new StatBasic(new NamespaceID("minecraft", "travel_pig"), "stat.pigOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_pig"), "stat.pigOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat jumpStat =
-        new StatBasic(new NamespaceID("minecraft", "jump"), "stat.jump").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "jump"), "stat.jump").setClientside().registerStat();
     public static Stat dropStat =
-        new StatBasic(new NamespaceID("minecraft", "drop"), "stat.drop").setClientside().registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "drop"), "stat.drop").setClientside().registerStat();
     public static Stat damageDealtStat =
-        new StatBasic(new NamespaceID("minecraft", "damage_dealt"), "stat.damageDealt").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "damage_dealt"), "stat.damageDealt").registerStat();
     public static Stat damageTakenStat =
-        new StatBasic(new NamespaceID("minecraft", "damage_taken"), "stat.damageTaken").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "damage_taken"), "stat.damageTaken").registerStat();
     public static Stat deathsStat =
-        new StatBasic(new NamespaceID("minecraft", "deaths"), "stat.deaths").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "deaths"), "stat.deaths").registerStat();
     public static Stat mobKillsStat =
-        new StatBasic(new NamespaceID("minecraft", "kills_mob"), "stat.mobKills").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "kills_mob"), "stat.mobKills").registerStat();
     public static Stat playerKillsStat =
-        new StatBasic(new NamespaceID("minecraft", "kills_player"), "stat.playerKills").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "kills_player"), "stat.playerKills").registerStat();
     public static Stat fishCaughtStat =
-        new StatBasic(new NamespaceID("minecraft", "caught_fish"), "stat.fishCaught").registerStat();
+        new StatBasic(NamespaceID.getPermanent("minecraft", "caught_fish"), "stat.fishCaught").registerStat();
 
     public static Map<NamespaceID, Stat> mobEncounterStats;
 
@@ -142,7 +142,7 @@ public abstract class StatList
         mobEncounterStats = new HashMap<>();
         for (Map.Entry<NamespaceID, Class<? extends Entity>> entry : EntityDispatcher.idToClassMap.entrySet())
         {
-            mobEncounterStats.put(entry.getKey(), new StatMob(new NamespaceID("minecraft", "encounter_" + entry.getKey().toString().replace(":", "_")), "stat.encounterMob", entry.getKey()).registerStat());
+            mobEncounterStats.put(entry.getKey(), new StatMob(NamespaceID.getPermanent("minecraft", "encounter_" + entry.getKey().toString().replace(":", "_")), "stat.encounterMob", entry.getKey()).registerStat());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 206539c86..4c56e4622 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -160,7 +160,7 @@ public class StatsCounter {
 				Stat stat;
 				try {
 					if (statId.contains(":")) {
-						stat = StatList.getStat(new NamespaceID(statId));
+						stat = StatList.getStat(NamespaceID.getTemp(statId));
 					} else {
 						stat = StatList.StatConverter.getStatFromDeprecatedID(Integer.parseInt(statId));
 					}
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 5a6044ada..d79b3b7dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -67,7 +67,7 @@ public final class Block<T extends BlockLogic>
     Supplier<@NotNull IItemConvertible> statParent = null;
 
     Block(int id, @NotNull String translationKey, @NotNull String namespaceId, @NotNull BlockLogicSupplier<T> logicSupplier) {
-        this.namespaceID = setupNamespaceId(namespaceId);
+        this.namespaceID = setupNamespaceId(namespaceId).makePermanent();
         this.key = setupTranslationKey(translationKey);
         this.id = setupNumericId(id);
 
@@ -112,7 +112,7 @@ public final class Block<T extends BlockLogic>
 //            namespaceId = parts[0] + ":" + "block/" + parts[1];
 //        }
         try {
-            return new NamespaceID(namespaceId);
+            return NamespaceID.getPermanent(namespaceId);
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index a5a326a4d..94c334efb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -20,6 +20,7 @@ public class TileEntityDispatcher {
         if(idToClassMap.containsKey(id)) {
             throw new IllegalArgumentException("Duplicate id: " + id);
         }
+        id.makePermanent();
 
         idToClassMap.put(id, entityClass);
         stringToClassMap.put(id.toString(), entityClass);
@@ -68,24 +69,24 @@ public class TileEntityDispatcher {
     public static void init() {
         if (hasInit) return;
         hasInit = true;
-        addMapping(TileEntityFurnace.class, new NamespaceID("minecraft", "furnace"));
-        addMapping(TileEntityChest.class, new NamespaceID("minecraft", "chest"));
-        addMapping(TileEntityJukebox.class, new NamespaceID("minecraft", "jukebox"));
-        addMapping(TileEntityDispenser.class, new NamespaceID("minecraft", "dispenser"));
-        addMapping(TileEntityActivator.class, new NamespaceID("minecraft", "activator"));
-        addMapping(TileEntitySign.class, new NamespaceID("minecraft", "sign"));
-        addMapping(TileEntityMobSpawner.class, new NamespaceID("minecraft", "mob_spawner"));
-        addMapping(TileEntityMovingPistonBlock.class, new NamespaceID("minecraft", "piston_moving"));
-        addMapping(TileEntityFurnaceBlast.class, new NamespaceID("minecraft", "furnace_blast"));
-        addMapping(TileEntitySensor.class, new NamespaceID("minecraft", "sensor"));
-        addMapping(TileEntityTrommel.class, new NamespaceID("minecraft", "trommel"));
-        addMapping(TileEntityBasket.class, new NamespaceID("minecraft", "basket"));
-        addMapping(TileEntityFlag.class, new NamespaceID("minecraft", "flag"));
-        addMapping(TileEntitySeat.class, new NamespaceID("minecraft", "seat"));
-        addMapping(TileEntityFlowerJar.class, new NamespaceID("minecraft", "jar_flower"));
-        addMapping(TileEntityJarButterfly.class, new NamespaceID("minecraft", "jar_butterfly"));
-        addMapping(TileEntityMeshGold.class, new NamespaceID("minecraft", "mesh_gold"));
-        addMapping(TileEntityStatue.class, new NamespaceID("minecraft", "statue_stone"));
+        addMapping(TileEntityFurnace.class, NamespaceID.getPermanent("minecraft", "furnace"));
+        addMapping(TileEntityChest.class, NamespaceID.getPermanent("minecraft", "chest"));
+        addMapping(TileEntityJukebox.class, NamespaceID.getPermanent("minecraft", "jukebox"));
+        addMapping(TileEntityDispenser.class, NamespaceID.getPermanent("minecraft", "dispenser"));
+        addMapping(TileEntityActivator.class, NamespaceID.getPermanent("minecraft", "activator"));
+        addMapping(TileEntitySign.class, NamespaceID.getPermanent("minecraft", "sign"));
+        addMapping(TileEntityMobSpawner.class, NamespaceID.getPermanent("minecraft", "mob_spawner"));
+        addMapping(TileEntityMovingPistonBlock.class, NamespaceID.getPermanent("minecraft", "piston_moving"));
+        addMapping(TileEntityFurnaceBlast.class, NamespaceID.getPermanent("minecraft", "furnace_blast"));
+        addMapping(TileEntitySensor.class, NamespaceID.getPermanent("minecraft", "sensor"));
+        addMapping(TileEntityTrommel.class, NamespaceID.getPermanent("minecraft", "trommel"));
+        addMapping(TileEntityBasket.class, NamespaceID.getPermanent("minecraft", "basket"));
+        addMapping(TileEntityFlag.class, NamespaceID.getPermanent("minecraft", "flag"));
+        addMapping(TileEntitySeat.class, NamespaceID.getPermanent("minecraft", "seat"));
+        addMapping(TileEntityFlowerJar.class, NamespaceID.getPermanent("minecraft", "jar_flower"));
+        addMapping(TileEntityJarButterfly.class, NamespaceID.getPermanent("minecraft", "jar_butterfly"));
+        addMapping(TileEntityMeshGold.class, NamespaceID.getPermanent("minecraft", "mesh_gold"));
+        addMapping(TileEntityStatue.class, NamespaceID.getPermanent("minecraft", "statue_stone"));
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 943dbdf37..1313923c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -189,7 +189,7 @@ public class TileEntityFurnace extends TileEntity
             	}
         	}
         	
-            if(currentBurnTime == 0 && canSmelt())
+            if(currentBurnTime == 0 && furnaceItemStacks[1] != null && canSmelt())
             {
                 maxBurnTime = currentBurnTime = getBurnTimeFromItem(furnaceItemStacks[1]);
                 if(currentBurnTime > 0)
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index 67bca0761..ad833a99a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -77,16 +77,9 @@ public class TileEntitySign extends TileEntity
         this.owner = player.uuid;
     }
 
-    public EnumSignPicture getPicture()
+    public @Nullable EnumSignPicture getPicture()
     {
-        if (selectedPicture < 0) return null;
-
-        for (EnumSignPicture picture : EnumSignPicture.values())
-        {
-            if (picture.getId() == selectedPicture) return picture;
-        }
-
-        return null;
+        return EnumSignPicture.fromId(selectedPicture);
     }
 
     public void setPicture(EnumSignPicture picture)
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 321ff8109..08628163d 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -52,7 +52,7 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
                 item = Item.itemsList[e.getAsInt()];
             } catch (NumberFormatException ignored) { // NumberFormatException thrown if element is not actually convertible to a number
                 try {
-                    item = Item.itemsMap.get(new NamespaceID(e.getAsString()));
+                    item = Item.itemsMap.get(NamespaceID.getTemp(e.getAsString()));
                 } catch (HardIllegalArgumentException ex) {
                     throw new JsonParseException(ex);
                 }
